import java.io.PrintWriter;
import java.io.StringWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

/*
 * Test.java
 *
 * Created on 30 June 2004, 11:54
 */

/**
 *
 * @author  Administrator
 */
public class Test {
    
    /** Creates a new instance of Test */
    public Test() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            Class driver_class = Class.forName("com.mysql.jdbc.Driver");

            // Create Read connection
            Connection read_con = DriverManager.getConnection("jdbc:mysql://127.0.0.1:3306/mytest", "root", "");
            read_con.setReadOnly(true);
            read_con.setAutoCommit(false);

            // Create Second Read connection
            Connection read_con2 = DriverManager.getConnection("jdbc:mysql://127.0.0.1:3306/mytest", "root", "");
            read_con2.setReadOnly(true);
            read_con2.setAutoCommit(false);

            // Create update connection
            Connection update_con = DriverManager.getConnection("jdbc:mysql://127.0.0.1:3306/mytest", "root", "");
            update_con.setAutoCommit(false);

            doQuery(read_con);

            doInsert(update_con, "new");

            doInsert(update_con, "new1");

            System.out.println("Query with used connection");
            doQuery(read_con);

            System.out.println("Query with unused connection");
            doQuery(read_con2);

            doDelete(update_con, "new");

            doDelete(update_con, "new1");

            doQuery(read_con);

            read_con.close();
            read_con = null;
            
            update_con.close();
            update_con = null;
        }
        catch (Exception e)
        {
            printStackTrace(e);
        }
    }

    private static void doQuery(Connection con)
    {
        // Execute query
        PreparedStatement ps = null;
        ResultSet rs = null;
        try
        {
            ps = con.prepareStatement("select name from testtable;");
            rs = ps.executeQuery();

            System.out.println("select name from testtable;");
            while (rs.next())
            {
                System.out.println(rs.getString(1));
            }
        }
        catch (SQLException e)
        {
            printStackTrace(e);
            return;
        }
        finally
        {
            tidyUp(rs, ps);
            rs = null;
            ps = null;
            System.out.println();
        }
    }

    private static void doInsert(Connection con, String value)
    {
        // Execute insert
        PreparedStatement ps = null;
        try
        {
            ps = con.prepareStatement("insert into testtable values ('" + value + "');");

            System.out.println("insert into testtable values ('" + value + "');");
            ps.executeUpdate();
            
            con.commit();
        }
        catch (SQLException e)
        {
            printStackTrace(e);
            try
            {
                con.rollback();
            }
            catch (SQLException e2)
            {
                printStackTrace(e2);
            }
            return;
        }
        finally
        {
            tidyUp(null, ps);
            ps = null;
            System.out.println();
        }
    }

    private static void doDelete(Connection con, String value)
    {
        // Execute insert
        PreparedStatement ps = null;
        try
        {
            ps = con.prepareStatement("delete from testtable where name='" + value + "';");

            System.out.println("delete from testtable where name='" + value + "';");
            ps.executeUpdate();
            
            con.commit();
        }
        catch (SQLException e)
        {
            printStackTrace(e);
            try
            {
                con.rollback();
            }
            catch (SQLException e2)
            {
                printStackTrace(e2);
            }
            return;
        }
        finally
        {
            tidyUp(null, ps);
            ps = null;
            System.out.println();
        }
    }

    private static void printStackTrace(Exception e)
    {
        StringWriter sw = new StringWriter();
        PrintWriter pr = new PrintWriter(sw);
        e.printStackTrace(pr);
        System.out.println(sw.toString());
    }
    
    private static void tidyUp(ResultSet rs, PreparedStatement ps)
    {
        try
        {
            if (rs != null)
                rs.close();
        }
        catch (SQLException e)
        {
            printStackTrace(e);
        }

        try
        {
            if (ps != null)
                ps.close();
        }
        catch (SQLException e)
        {
            printStackTrace(e);
        }
    }
}
